## ruy 0.0.0~git20230215.21a85fe

=== CMakeLists.txt ===
# Copyright 2021 Google LLC
#
# Licensed under the Apache License, Version 2.0 (the "License");
# you may not use this file except in compliance with the License.
# You may obtain a copy of the License at
#
#      https://www.apache.org/licenses/LICENSE-2.0
#
# Unless required by applicable law or agreed to in writing, software
# distributed under the License is distributed on an "AS IS" BASIS,
# WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
# See the License for the specific language governing permissions and
# limitations under the License.

cmake_policy(SET CMP0012 NEW)
cmake_policy(SET CMP0048 NEW)
project(ruy CXX)
cmake_minimum_required(VERSION 3.13)  # Copied from IREE
set(CMAKE_CXX_STANDARD 14)

include(GNUInstallDirs)

if (PROJECT_NAME STREQUAL CMAKE_PROJECT_NAME)
  set(RUY_IS_TOPLEVEL TRUE)
  set(RUY_MINIMAL_BUILD_DEFAULT_VALUE OFF)
else()
  set(RUY_IS_TOPLEVEL FALSE)
  set(RUY_MINIMAL_BUILD_DEFAULT_VALUE ON)
endif()

option(RUY_MINIMAL_BUILD "Disable ruy's tests, examples, etc. Build only ruy public libraries." ${RUY_MINIMAL_BUILD_DEFAULT_VALUE})
if (NOT RUY_MINIMAL_BUILD)
  enable_testing()
endif()

option(RUY_PROFILER "Enable ruy's built-in profiler (harms performance)" OFF)

option(RUY_ENABLE_INSTALL "Enable install rule" ${RUY_IS_TOPLEVEL})

include(cmake/ruy_add_all_subdirs.cmake)
include(cmake/ruy_cc_library.cmake)
include(cmake/ruy_cc_binary.cmake)
include(cmake/ruy_cc_test.cmake)

option(RUY_FIND_CPUINFO "Use find_package to find cpuinfo" OFF)

# Skip cpuinfo if it was already generated, which can happen when ruy is
# a subdirectory in a wider project that already uses cpuinfo.
if (NOT TARGET cpuinfo::cpuinfo)
  if (RUY_FIND_CPUINFO)
    find_package(cpuinfo REQUIRED)
  else()
    # Test if the third_party/cpuinfo submodule was checked out before
    # adding that subdirectory, so we can do more helpful things below in the
    # else() block when it's not.
    set(RUY_CPUINFO_CMAKELISTS_FILE "${CMAKE_CURRENT_SOURCE_DIR}/third_party/cpuinfo/CMakeLists.txt")
    if (EXISTS "${RUY_CPUINFO_CMAKELISTS_FILE}")
      # Disabling cpuinfo's tests and benchmarks to prevent a copy of its
      # googletest dependency getting downloaded into a 'deps' directory in the
      # source tree!
      set(CPUINFO_BUILD_BENCHMARKS OFF CACHE BOOL "" FORCE)
      set(CPUINFO_BUILD_UNIT_TESTS OFF CACHE BOOL "" FORCE)
      set(CPUINFO_BUILD_MOCK_TESTS OFF CACHE BOOL "" FORCE)
      add_subdirectory("third_party/cpuinfo" EXCLUDE_FROM_ALL)
    else()
      # third_party/cpuinfo is not checked out. That could be intentional when
      # ruy is a subdirectory in a wider project that is already providing
      # the cpuinfo target. Maybe that wider project's CMakeLists is ordered
      # in such a way that cpuinfo gets generated after ruy. In that case,
      # it's helpful that we continue silently. In the worst case if the cpuinfo
      # target never gets defined, ruy will fail to compile.
      # On the other hand, if ruy is the top-level project here (not part of a
      # wider project) then nothing will define the cpuinfo target for us,
      # so we will definitely fail to compile, so we may as well fail right here.
      if (RUY_IS_TOPLEVEL)
        message(FATAL_ERROR "This file does not exist:\n${RUY_CPUINFO_CMAKELISTS_FILE}\n"
                      "That typically means that the git submodules of the ruy "
                      "repository haven't been checked out. Try this in the ruy "
                      "git directory:\n  git submodule update --init")
      endif()
    endif()
  endif()
endif()

# googletest is only needed for tests. Projects embedding ruy as a subdirectory
# and not needing to build ruy tests may proceed without a local checkout of
# third_party/googletest.
if (NOT RUY_MINIMAL_BUILD
    AND NOT TARGET gtest
    AND EXISTS "${CMAKE_CURRENT_SOURCE_DIR}/third_party/googletest/CMakeLists.txt")
  add_subdirectory("third_party/googletest" EXCLUDE_FROM_ALL)
endif()

add_subdirectory("ruy")

if (NOT RUY_MINIMAL_BUILD)
  add_subdirectory("example")
endif()

if (RUY_ENABLE_INSTALL)
  install(EXPORT ${PROJECT_NAME}Targets
    NAMESPACE ${PROJECT_NAME}::
    DESTINATION "${CMAKE_INSTALL_LIBDIR}/cmake/${PROJECT_NAME}"
  )

  include(CMakePackageConfigHelpers)

  configure_package_config_file(
    "cmake/${PROJECT_NAME}Config.cmake.in"
    "${PROJECT_BINARY_DIR}/${PROJECT_NAME}Config.cmake"
    INSTALL_DESTINATION "${CMAKE_INSTALL_LIBDIR}/cmake/${PROJECT_NAME}"
  )

  install(FILES "${PROJECT_BINARY_DIR}/${PROJECT_NAME}Config.cmake"
    DESTINATION "${CMAKE_INSTALL_LIBDIR}/cmake/${PROJECT_NAME}"
  )
endif()

=== example/CMakeLists.txt ===
# This file is generated (whence no license header). Do not edit!
# To regenerate, run:
#   cmake/bazel_to_cmake.sh

ruy_cc_binary(
  NAME
    ruy_example_example
  SRCS
    example.cc
  DEPS
    ruy
)

ruy_cc_binary(
  NAME
    ruy_example_parametrized_example
  SRCS
    parametrized_example.cc
  DEPS
    ruy
)

ruy_add_all_subdirs()

=== ruy/CMakeLists.txt ===
# This file is generated (whence no license header). Do not edit!
# To regenerate, run:
#   cmake/bazel_to_cmake.sh

if(CMAKE_SYSTEM_NAME STREQUAL Windows)
  set(ruy_0_Wall_Wcxx14_compat_Wextra_Wundef "")
else()
  set(ruy_0_Wall_Wcxx14_compat_Wextra_Wundef "-Wall;-Wextra;-Wc++14-compat;-Wundef")
endif()

if(CMAKE_SYSTEM_PROCESSOR STREQUAL arm)
  set(ruy_1_mfpu_neon "-mfpu=neon")
else()
  set(ruy_1_mfpu_neon "")
endif()

if((CMAKE_BUILD_TYPE STREQUAL Debug) OR MSVC)
  set(ruy_2_O3 "")
else()
  set(ruy_2_O3 "-O3")
endif()

ruy_cc_library(
  NAME
    ruy_trace
  HDRS
    trace.h
  COPTS
    ${ruy_0_Wall_Wcxx14_compat_Wextra_Wundef}
    ${ruy_1_mfpu_neon}
    ${ruy_2_O3}
  DEPS
    ruy_mat
    ruy_matrix
    ruy_path
    ruy_platform
    ruy_side_pair
)

ruy_cc_library(
  NAME
    ruy_platform
  HDRS
    platform.h
  COPTS
    ${ruy_0_Wall_Wcxx14_compat_Wextra_Wundef}
    ${ruy_1_mfpu_neon}
    ${ruy_2_O3}
)

ruy_cc_library(
  NAME
    ruy_gtest_wrapper
  TESTONLY
  HDRS
    gtest_wrapper.h
  DEPS
    gtest
)

ruy_cc_library(
  NAME
    ruy_check_macros
  HDRS
    check_macros.h
  COPTS
    ${ruy_0_Wall_Wcxx14_compat_Wextra_Wundef}
    ${ruy_1_mfpu_neon}
    ${ruy_2_O3}
)

ruy_cc_test(
  NAME
    ruy_check_macros_test
  SRCS
    check_macros_test.cc
  COPTS
    ${ruy_0_Wall_Wcxx14_compat_Wextra_Wundef}
    ${ruy_1_mfpu_neon}
    ${ruy_2_O3}
  DEPS
    ruy_check_macros
    ruy_gtest_wrapper
)

ruy_cc_library(
  NAME
    ruy_opt_set
  HDRS
    opt_set.h
  COPTS
    ${ruy_0_Wall_Wcxx14_compat_Wextra_Wundef}
    ${ruy_1_mfpu_neon}
    ${ruy_2_O3}
)

ruy_cc_library(
  NAME
    ruy_time
  HDRS
    time.h
  COPTS
    ${ruy_0_Wall_Wcxx14_compat_Wextra_Wundef}
    ${ruy_1_mfpu_neon}
    ${ruy_2_O3}
)

if(CMAKE_SYSTEM_NAME STREQUAL Windows)
  set(ruy_3_pthread "")
else()
  set(ruy_3_pthread "-pthread")
endif()

ruy_cc_library(
  NAME
    ruy_wait
  SRCS
    wait.cc
  HDRS
    wait.h
  COPTS
    ${ruy_0_Wall_Wcxx14_compat_Wextra_Wundef}
    ${ruy_1_mfpu_neon}
    ${ruy_2_O3}
  LINKOPTS
    ${ruy_3_pthread}
  DEPS
    ruy_time
)

ruy_cc_test(
  NAME
    ruy_wait_test
  SRCS
    wait_test.cc
  COPTS
    ${ruy_0_Wall_Wcxx14_compat_Wextra_Wundef}
    ${ruy_1_mfpu_neon}
    ${ruy_2_O3}
  LINKOPTS
    ${ruy_3_pthread}
  DEPS
    ruy_gtest_wrapper
    ruy_platform
    ruy_wait
)

ruy_cc_library(
  NAME
    ruy_size_util
  HDRS
    size_util.h
  COPTS
    ${ruy_0_Wall_Wcxx14_compat_Wextra_Wundef}
    ${ruy_1_mfpu_neon}
    ${ruy_2_O3}
  DEPS
    ruy_check_macros
)

ruy_cc_test(
  NAME
    ruy_size_util_test
  SRCS
    size_util_test.cc
  COPTS
    ${ruy_0_Wall_Wcxx14_compat_Wextra_Wundef}
    ${ruy_1_mfpu_neon}
    ${ruy_2_O3}
  DEPS
    ruy_gtest_wrapper
    ruy_size_util
)

ruy_cc_library(
  NAME
    ruy_tune
  SRCS
    tune.cc
  HDRS
    tune.h
  COPTS
    ${ruy_0_Wall_Wcxx14_compat_Wextra_Wundef}
    ${ruy_1_mfpu_neon}
    ${ruy_2_O3}
  DEPS
    ruy_cpu_cache_params
    ruy_cpuinfo
    ruy_opt_set
    ruy_platform
    ruy_time
)

ruy_cc_library(
  NAME
    ruy_system_aligned_alloc
  SRCS
    system_aligned_alloc.cc
  HDRS
    system_aligned_alloc.h
  COPTS
    ${ruy_0_Wall_Wcxx14_compat_Wextra_Wundef}
    ${ruy_1_mfpu_neon}
    ${ruy_2_O3}
)

ruy_cc_library(
  NAME
    ruy_prepacked_cache
  SRCS
    prepacked_cache.cc
  HDRS
    prepacked_cache.h
  COPTS
    ${ruy_0_Wall_Wcxx14_compat_Wextra_Wundef}
    ${ruy_1_mfpu_neon}
    ${ruy_2_O3}
  DEPS
    ruy_mat
    ruy_system_aligned_alloc
    ruy_profiler_instrumentation
)

ruy_cc_test(
  NAME
    ruy_tune_test
  SRCS
    tune_test.cc
  COPTS
    ${ruy_0_Wall_Wcxx14_compat_Wextra_Wundef}
    ${ruy_1_mfpu_neon}
    ${ruy_2_O3}
  DEPS
    ruy_cpuinfo
    ruy_gtest_wrapper
    ruy_tune
)

ruy_cc_test(
  NAME
    ruy_prepacked_cache_test
  SRCS
    prepacked_cache_test.cc
  COPTS
    ${ruy_0_Wall_Wcxx14_compat_Wextra_Wundef}
    ${ruy_1_mfpu_neon}
    ${ruy_2_O3}
  DEPS
    ruy_context
    ruy_context_get_ctx
    ruy_ctx
    ruy_gtest_wrapper
    ruy_mat
    ruy_matrix
    ruy_prepacked_cache
    ruy
    ruy_time
)

ruy_cc_library(
  NAME
    ruy_allocator
  SRCS
    allocator.cc
  HDRS
    allocator.h
  COPTS
    ${ruy_0_Wall_Wcxx14_compat_Wextra_Wundef}
    ${ruy_1_mfpu_neon}
    ${ruy_2_O3}
  DEPS
    ruy_opt_set
    ruy_size_util
    ruy_system_aligned_alloc
)

ruy_cc_test(
  NAME
    ruy_allocator_test
  SRCS
    allocator_test.cc
  COPTS
    ${ruy_0_Wall_Wcxx14_compat_Wextra_Wundef}
    ${ruy_1_mfpu_neon}
    ${ruy_2_O3}
  DEPS
    ruy_allocator
    ruy_gtest_wrapper
)

ruy_cc_library(
  NAME
    ruy_side_pair
  HDRS
    side_pair.h
  COPTS
    ${ruy_0_Wall_Wcxx14_compat_Wextra_Wundef}
    ${ruy_1_mfpu_neon}
    ${ruy_2_O3}
  DEPS
    ruy_check_macros
)

ruy_cc_library(
  NAME
    ruy_block_map
  SRCS
    block_map.cc
  HDRS
    block_map.h
  COPTS
    ${ruy_0_Wall_Wcxx14_compat_Wextra_Wundef}
    ${ruy_1_mfpu_neon}
    ${ruy_2_O3}
  DEPS
    ruy_check_macros
    ruy_cpu_cache_params
    ruy_opt_set
    ruy_side_pair
    ruy_size_util
    ruy_trace
    ruy_profiler_instrumentation
)

ruy_cc_test(
  NAME
    ruy_block_map_test
  SRCS
    block_map_test.cc
  COPTS
    ${ruy_0_Wall_Wcxx14_compat_Wextra_Wundef}
    ${ruy_1_mfpu_neon}
    ${ruy_2_O3}
  DEPS
    ruy_block_map
    ruy_cpu_cache_params
    ruy_gtest_wrapper
    ruy_path
    ruy_platform
    ruy_side_pair
)

ruy_cc_library(
  NAME
    ruy_blocking_counter
  SRCS
    blocking_counter.cc
  HDRS
    blocking_counter.h
  COPTS
    ${ruy_0_Wall_Wcxx14_compat_Wextra_Wundef}
    ${ruy_1_mfpu_neon}
    ${ruy_2_O3}
  LINKOPTS
    ${ruy_3_pthread}
  DEPS
    ruy_check_macros
    ruy_time
    ruy_wait
)

ruy_cc_library(
  NAME
    ruy_thread_pool
  SRCS
    thread_pool.cc
  HDRS
    thread_pool.h
  COPTS
    ${ruy_0_Wall_Wcxx14_compat_Wextra_Wundef}
    ${ruy_1_mfpu_neon}
    ${ruy_2_O3}
  LINKOPTS
    ${ruy_3_pthread}
  PUBLIC
  DEPS
    ruy_blocking_counter
    ruy_check_macros
    ruy_denormal
    ruy_time
    ruy_trace
    ruy_wait
)

ruy_cc_library(
  NAME
    ruy_cpu_cache_params
  HDRS
    cpu_cache_params.h
  COPTS
    ${ruy_0_Wall_Wcxx14_compat_Wextra_Wundef}
    ${ruy_1_mfpu_neon}
    ${ruy_2_O3}
)

if(CMAKE_SYSTEM_NAME STREQUAL Windows)
  set(ruy_4_Wno_undef "")
else()
  set(ruy_4_Wno_undef "-Wno-undef")
endif()

if(CMAKE_SYSTEM_PROCESSOR STREQUAL ppc64 OR CMAKE_SYSTEM_PROCESSOR STREQUAL ppc64le)
  set(ruy_5_DRUY_HAVE_CPUINFO "")
elseif(CMAKE_SYSTEM_PROCESSOR STREQUAL s390 OR CMAKE_SYSTEM_PROCESSOR STREQUAL s390x)
  set(ruy_5_DRUY_HAVE_CPUINFO "")
elseif(CMAKE_SYSTEM_NAME STREQUAL Fuchsia)
  set(ruy_5_DRUY_HAVE_CPUINFO "")
else()
  set(ruy_5_DRUY_HAVE_CPUINFO "-DRUY_HAVE_CPUINFO")
endif()

if(CMAKE_SYSTEM_PROCESSOR STREQUAL ppc64 OR CMAKE_SYSTEM_PROCESSOR STREQUAL ppc64le)
  set(ruy_6_cpuinfo_cpuinfo "")
elseif(CMAKE_SYSTEM_PROCESSOR STREQUAL s390 OR CMAKE_SYSTEM_PROCESSOR STREQUAL s390x)
  set(ruy_6_cpuinfo_cpuinfo "")
elseif(CMAKE_SYSTEM_NAME STREQUAL Fuchsia)
  set(ruy_6_cpuinfo_cpuinfo "")
else()
  set(ruy_6_cpuinfo_cpuinfo "cpuinfo::cpuinfo")
endif()

ruy_cc_library(
  NAME
    ruy_cpuinfo
  SRCS
    cpuinfo.cc
  HDRS
    cpuinfo.h
  COPTS
    ${ruy_0_Wall_Wcxx14_compat_Wextra_Wundef}
    ${ruy_1_mfpu_neon}
    ${ruy_2_O3}
    ${ruy_4_Wno_undef}
    ${ruy_5_DRUY_HAVE_CPUINFO}
  DEPS
    ruy_platform
    ruy_check_macros
    ruy_cpu_cache_params
    ${ruy_6_cpuinfo_cpuinfo}
)

ruy_cc_library(
  NAME
    ruy_path
  HDRS
    path.h
  COPTS
    ${ruy_0_Wall_Wcxx14_compat_Wextra_Wundef}
    ${ruy_1_mfpu_neon}
    ${ruy_2_O3}
  PUBLIC
  DEPS
    ruy_platform
    ruy_size_util
)

ruy_cc_library(
  NAME
    ruy_denormal
  SRCS
    denormal.cc
  HDRS
    denormal.h
  COPTS
    ${ruy_0_Wall_Wcxx14_compat_Wextra_Wundef}
    ${ruy_1_mfpu_neon}
    ${ruy_2_O3}
  PUBLIC
)

ruy_cc_library(
  NAME
    ruy_performance_advisory
  HDRS
    performance_advisory.h
  COPTS
    ${ruy_0_Wall_Wcxx14_compat_Wextra_Wundef}
    ${ruy_1_mfpu_neon}
    ${ruy_2_O3}
  PUBLIC
)

ruy_cc_library(
  NAME
    ruy_matrix
  HDRS
    matrix.h
  COPTS
    ${ruy_0_Wall_Wcxx14_compat_Wextra_Wundef}
    ${ruy_1_mfpu_neon}
    ${ruy_2_O3}
  PUBLIC
  DEPS
    ruy_check_macros
)

ruy_cc_test(
  NAME
    ruy_matrix_test
  SRCS
    matrix_test.cc
  COPTS
    ${ruy_0_Wall_Wcxx14_compat_Wextra_Wundef}
    ${ruy_1_mfpu_neon}
    ${ruy_2_O3}
  DEPS
    ruy_gtest_wrapper
    ruy_matrix
)

ruy_cc_library(
  NAME
    ruy_mul_params
  HDRS
    mul_params.h
  COPTS
    ${ruy_0_Wall_Wcxx14_compat_Wextra_Wundef}
    ${ruy_1_mfpu_neon}
    ${ruy_2_O3}
  PUBLIC
  DEPS
    ruy_check_macros
    ruy_size_util
)

ruy_cc_test(
  NAME
    ruy_mul_params_test
  SRCS
    mul_params_test.cc
  COPTS
    ${ruy_0_Wall_Wcxx14_compat_Wextra_Wundef}
    ${ruy_1_mfpu_neon}
    ${ruy_2_O3}
  DEPS
    ruy_gtest_wrapper
    ruy_mul_params
)

ruy_cc_library(
  NAME
    ruy_mat
  HDRS
    mat.h
  COPTS
    ${ruy_0_Wall_Wcxx14_compat_Wextra_Wundef}
    ${ruy_1_mfpu_neon}
    ${ruy_2_O3}
  DEPS
    ruy_check_macros
    ruy_matrix
    ruy_size_util
)

ruy_cc_library(
  NAME
    ruy_asm_helpers
  HDRS
    asm_helpers.h
  COPTS
    ${ruy_0_Wall_Wcxx14_compat_Wextra_Wundef}
    ${ruy_1_mfpu_neon}
    ${ruy_2_O3}
  DEPS
    ruy_opt_set
)

ruy_cc_library(
  NAME
    ruy_apply_multiplier
  SRCS
    apply_multiplier.cc
  HDRS
    apply_multiplier.h
  COPTS
    ${ruy_0_Wall_Wcxx14_compat_Wextra_Wundef}
    ${ruy_1_mfpu_neon}
    ${ruy_2_O3}
  DEPS
    ruy_check_macros
    ruy_mul_params
)

ruy_cc_test(
  NAME
    ruy_apply_multiplier_test
  SRCS
    apply_multiplier_test.cc
  COPTS
    ${ruy_0_Wall_Wcxx14_compat_Wextra_Wundef}
    ${ruy_1_mfpu_neon}
    ${ruy_2_O3}
  DEPS
    ruy_apply_multiplier
    ruy_gtest_wrapper
    ruy_mul_params
)

ruy_cc_library(
  NAME
    ruy_kernel_common
  HDRS
    kernel_common.h
  COPTS
    ${ruy_0_Wall_Wcxx14_compat_Wextra_Wundef}
    ${ruy_1_mfpu_neon}
    ${ruy_2_O3}
  DEPS
    ruy_apply_multiplier
    ruy_check_macros
    ruy_mat
    ruy_matrix
    ruy_mul_params
    ruy_opt_set
    ruy_path
    ruy_platform
    ruy_side_pair
    ruy_size_util
    ruy_tune
    ruy_profiler_instrumentation
)

ruy_cc_library(
  NAME
    ruy_pack_common
  HDRS
    pack_common.h
  COPTS
    ${ruy_0_Wall_Wcxx14_compat_Wextra_Wundef}
    ${ruy_1_mfpu_neon}
    ${ruy_2_O3}
  DEPS
    ruy_check_macros
    ruy_mat
    ruy_matrix
    ruy_opt_set
    ruy_path
    ruy_platform
    ruy_tune
    ruy_profiler_instrumentation
)

ruy_cc_library(
  NAME
    ruy_kernel_arm
  SRCS
    kernel_arm32.cc
    kernel_arm64.cc
  HDRS
    kernel_arm.h
  COPTS
    ${ruy_0_Wall_Wcxx14_compat_Wextra_Wundef}
    ${ruy_1_mfpu_neon}
    ${ruy_2_O3}
  DEPS
    ruy_asm_helpers
    ruy_check_macros
    ruy_kernel_common
    ruy_mat
    ruy_mul_params
    ruy_opt_set
    ruy_path
    ruy_platform
    ruy_side_pair
    ruy_size_util
    ruy_tune
    ruy_profiler_instrumentation
)

ruy_cc_library(
  NAME
    ruy_pack_arm
  SRCS
    pack_arm.cc
  HDRS
    pack_arm.h
  COPTS
    ${ruy_0_Wall_Wcxx14_compat_Wextra_Wundef}
    ${ruy_1_mfpu_neon}
    ${ruy_2_O3}
  DEPS
    ruy_asm_helpers
    ruy_check_macros
    ruy_mat
    ruy_opt_set
    ruy_pack_common
    ruy_path
    ruy_platform
    ruy_tune
    ruy_profiler_instrumentation
)

if((CMAKE_SYSTEM_PROCESSOR STREQUAL x86_64 OR CMAKE_SYSTEM_PROCESSOR STREQUAL amd64) AND NOT MSVC)
  set(ruy_7_mavx512bw_mavx512cd_mavx512dq_mavx512f_mavx512vl_arch_AVX512 ";-mavx512f;-mavx512vl;-mavx512cd;-mavx512bw;-mavx512dq")
elseif(MSVC)
  set(ruy_7_mavx512bw_mavx512cd_mavx512dq_mavx512f_mavx512vl_arch_AVX512 "/arch:AVX512")
else()
  set(ruy_7_mavx512bw_mavx512cd_mavx512dq_mavx512f_mavx512vl_arch_AVX512 "")
endif()

ruy_cc_library(
  NAME
    ruy_kernel_avx512
  SRCS
    kernel_avx512.cc
  HDRS
    kernel_x86.h
  COPTS
    ${ruy_0_Wall_Wcxx14_compat_Wextra_Wundef}
    ${ruy_1_mfpu_neon}
    ${ruy_2_O3}
    ${ruy_7_mavx512bw_mavx512cd_mavx512dq_mavx512f_mavx512vl_arch_AVX512}
  DEPS
    ruy_check_macros
    ruy_kernel_common
    ruy_mat
    ruy_mul_params
    ruy_opt_set
    ruy_path
    ruy_platform
    ruy_tune
    ruy_profiler_instrumentation
)

=== third_party/CMakeLists.txt ===
# This file is generated (whence no license header). Do not edit!
# To regenerate, run:
#   cmake/bazel_to_cmake.sh

ruy_add_all_subdirs()

=== ruy/profiler/CMakeLists.txt ===
# This file is generated (whence no license header). Do not edit!
# To regenerate, run:
#   cmake/bazel_to_cmake.sh

if(${RUY_PROFILER})
  set(ruy_profiler_0_RUY_PROFILER "RUY_PROFILER")
else()
  set(ruy_profiler_0_RUY_PROFILER "")
endif()

if(CMAKE_SYSTEM_NAME STREQUAL Windows)
  set(ruy_profiler_1_pthread "")
else()
  set(ruy_profiler_1_pthread "-pthread")
endif()

ruy_cc_library(
  NAME
    ruy_profiler_instrumentation
  SRCS
    instrumentation.cc
  HDRS
    instrumentation.h
  DEFINES
    ${ruy_profiler_0_RUY_PROFILER}
  LINKOPTS
    ${ruy_profiler_1_pthread}
  PUBLIC
)

ruy_cc_library(
  NAME
    ruy_profiler_profiler
  SRCS
    profiler.cc
    treeview.cc
  HDRS
    profiler.h
    treeview.h
  LINKOPTS
    ${ruy_profiler_1_pthread}
  PUBLIC
  DEPS
    ruy_profiler_instrumentation
)

ruy_cc_library(
  NAME
    ruy_profiler_test_instrumented_library
  TESTONLY
  SRCS
    test_instrumented_library.cc
  HDRS
    test_instrumented_library.h
  DEPS
    ruy_profiler_instrumentation
)

ruy_cc_test(
  NAME
    ruy_profiler_test
  SRCS
    test.cc
  LINKOPTS
    ${ruy_profiler_1_pthread}
  DEPS
    ruy_profiler_profiler
    ruy_profiler_test_instrumented_library
    ruy_gtest_wrapper
)

ruy_add_all_subdirs()

=== debian/changelog ===
ruy (0.0.0~git20230215.21a85fe-2) unstable; urgency=medium

  [ Bardia Moshiri ]
  * debian: build with position independent code

  [ Dylan Aïssi ]
  * Add debian/upstream/metadata
  * Standards-Version: 4.7.2 (no changes required)
  * Ignore test results for ARM32 (Closes: #1067958)
  * Mark libruy-dev as Multi-Arch: same

 -- Dylan Aïssi <daissi@debian.org>  Sun, 06 Apr 2025 17:58:05 +0200

ruy (0.0.0~git20230215.21a85fe-1) unstable; urgency=medium

  * Initial release

 -- Dylan Aïssi <daissi@debian.org>  Sat, 17 Jun 2023 22:14:16 +0200

=== debian/control ===
Source: ruy
Section: science
Priority: optional
Maintainer: Debian Deep Learning Team <debian-ai@lists.debian.org>
Uploaders: Dylan Aïssi <daissi@debian.org>
Build-Depends: debhelper-compat (= 13),
               cmake,
               libcpuinfo-dev (>= 0.0~git20220617.082deff-2),
               libgtest-dev
Standards-Version: 4.7.2
Rules-Requires-Root: no
Vcs-Browser: https://salsa.debian.org/deeplearning-team/ruy
Vcs-Git: https://salsa.debian.org/deeplearning-team/ruy.git
Homepage: https://github.com/google/ruy

Package: libruy-dev
Architecture: any
Multi-Arch: same
Section: libdevel
Depends: ${misc:Depends}
Description: matrix multiplication library
 ruy is a matrix multiplication library. Its focus is to cover the matrix
 multiplication needs of neural network inference engines. Its initial user has
 been TensorFlow Lite, where it is used by default on the ARM CPU architecture.

=== debian/watch ===
version=4
opts="mode=git, pgpmode=none, pretty=0.0.0~git%cd.%h, repack, compression=xz" \
 https://github.com/google/ruy.git \
 HEAD
